/*!
 * RSS Feed(s) Widget
 */
( function( win ) {
	jQuery( function( $ ) {
		win.feedpress_generator_widget_feed = {
				// widget content initialization
				init: function( settings ) {
					var $list = $( '.feed-items' );

					// link target
					if ( settings.link_target == 'new' ) {
						$( 'a' ).attr( 'target', '_blank' );
					}

					// set list height
					var offset = $( '.feed-title' ).outerHeight() + $( '.widget-footer' ).outerHeight() + $( '.feed-footer' ).outerHeight() + 10;
					$( '.feed-items' ).css( 'height', ( parseInt( settings.height ) - offset ) + 'px' );

					// ago times
					$( '.entry-time' ).each( function() {
						$( this ).text( moment( $( this ).attr( 'datetime' ), 'YYYY-MM-DD' ).fromNow() );
					} );

					// auto-scrolling
					if ( settings.auto_scroll_enable === 'on' ) {						
						// horizontal scrolling fixes
						if ( settings.scroll_bar_dir === 'horizontal' ) {
							var list_width = $list.outerWidth(),
							$list_items = $list.find( '.feed-item' );
							
							// set feed items width
							$list_items.outerWidth( list_width );
							
							// set list width
							$list.outerWidth( list_width * $list_items.size() );
							var $scroll_target = $list.parent();
						} else {
							var $scroll_target = $list;
						}

						var step_duration = parseInt( settings.scroll_step ) * 1000,
							$current_target = $scroll_target.find( '.feed-item:first' );

						// timer callback
						var scroller = function() {
							// determine next target
							$current_target = $current_target.next();
							if ( $current_target.size() < 1 )
								$current_target = $scroll_target.find( '.feed-item:first' );

							// scroll to target
							$scroll_target.scrollTo( $current_target, 500 );
							
							// register interval
							setTimeout( scroller, step_duration );
						};

						// register interval
						setTimeout( scroller, step_duration );
					}
				},
				// start widget from outside
				start: function( settings, endpoint ) {
					// iframe stuff
					$( '#'+ settings.widget_id ).html( '<iframe width="'+ ( settings.responsive_width == 'on' ? '100%' : settings.width ) +'" ' +
							' height="'+ settings.height +'"' +
							' frameborder="0" marginwidth="0" src="'+ endpoint +'?'+ $.param( settings ) +'"' +
							' marginheight="0" vspace="0" hspace="0" scrolling="no"></iframe>' );
				}
		};
	} );
} )( window );